Bug 177853 - 2.6.15-1.1854_FC5 breaks named, 1853 is fine
2.6.15-1.1854_FC5 breaks named, 1853 is fine
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
All Linux
medium Severity high
: ---
: ---
Assigned To: Dave Jones
Brian Brock
Depends On:
Blocks: 177854
  Show dependency treegraph
Reported: 2006-01-15 12:52 EST by Alexandre Oliva
Modified: 2015-01-04 17:24 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-01-17 00:54:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Fix (5.82 KB, patch)
2006-01-16 06:44 EST, David Woodhouse
no flags Details | Diff

  None (edit)
Description Alexandre Oliva 2006-01-15 12:52:07 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.8) Gecko/20060103 Fedora/1.5-4 Firefox/1.5

Description of problem:
After today's rawhide update, that modified only the kernel and replaced pup with pirut, named would no longer respond to local queries.  Rebooting into yesterday's kernel fixed it.  I still haven't figured out what it was in the kernel that broke it, but it's pretty clear that it is the kernel that did it.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1.Boot a box with a local caching name server into 2.6.15-1.1854_FC5
2.Issue queries to the local named
3.Reboot into 2.6.15-1.1853_FC5
4.Issue the same queries

Actual Results:  2. times out, 4 works.

Expected Results:  2. should work

Additional info:
Comment 1 Jason Vas Dias 2006-01-15 18:09:06 EST
This is because the format of the /proc/net/if_inet6 file has changed, so 
named refuses to listen on any interfaces . named writes these log messages:

Jan 15 17:35:59 jvdias named[2527]: /proc/net/if_inet6:sscanf() -> 1 (expected 6)
Jan 15 17:35:59 jvdias named[2527]: interfacemgr.c:827: unexpected error:
Jan 15 17:35:59 jvdias named[2527]: interface iteration failed: failure
Jan 15 17:35:59 jvdias named[2527]: not listening on any interfaces

In previous kernels, the /proc/net/if_inet6 looked like this:
$ cat /proc/net/if_inet6
00000000000000000000000000000001 01 80 10 80       lo
fe8000000000000002d059fffecf1a3d 02 40 20 80     eth0

Now, in 2.6.15-1.1854_FC5, it looks like this:
0000:0000:0000:0000:0000:0000:0000:0001 01 80 10 80       lo
fe80:0000:0000:0000:020d:60ff:fecf:98e3 02 40 20 80     eth0

So named's sscanf of this file fails, and it refuses to listen on any
interface, because it cannot determine the ipv6 status of any interface
(this is probably correct, as it prevents named attempting to work on
kernels / OS's it has never been tested on and knows nothing about).

It seems very silly to me to suddenly change the IPv6 address format of
this file, since all software knows each line must begin with an 128-bit
IPv6 address ; the colons (':'s) are irrelevant, and break software such
as named that read this file not expecting the colons in the address.

Please could the kernel maintainers let me know whether this change is going
to be permanent, in which case I'll change named's sscanf format to take 
account of this change, or whether this change will be backed out in the next
kernel release (as I believe it should be) - thanks.
Comment 2 David Woodhouse 2006-01-16 06:44:29 EST
Created attachment 123231 [details]

This patch fixes the bug, and should turn up in Linus' tree fairly shortly.
Comment 3 Jason Vas Dias 2006-01-16 12:58:16 EST
But please can we apply this patch to our rawhide kernel release ASAP -
2.6.15-1857_FC5 still has the same problem, so named is disabled in rawhide
at the moment, until this bug is fixed. 
Please let me know when the patch will be applied to the rawhide kernel -
if longer than 1 day, I'll patch named to recognize both formats - thanks .

Comment 4 Dave Jones 2006-01-17 00:54:01 EST
added to cvs. will be in tomorrows build.

Davem, can you push that to Linus asap ?
Comment 5 David Miller 2006-01-17 17:42:01 EST
I submitted it last night.

He didn't take it yet, but he should in the next day or two.
I was busy over the weekend and thus didn't get it in before
2.6.16-rc1 was cut.

Note You need to log in before you can comment on or make changes to this bug.